#include <stdio.h>
#include "LALStdlib.h"
#include "Comm.h"
#include "Stubs.h"

/* print out templates */
void PrintTemplate(tempstruct *list,INT4 number,mpiid id){
    INT4 i;
    for (i=0;i<number;i++)
        printf("Slave %d => template %d mass1=%f mass2=%f\n",id.myid
               ,list[i].templatenumber,list[i].m1,list[i].m2);
    fflush(stdout);
    return;
}

/* print out events */
void PrintEvents(EventPacket *list,INT4 number,INT4 source) {
    INT4 i;
    EventPacket pkt;
    
    for (i=0;i<number;i++){
        pkt=list[i];
        printf("Slave %d found ==> "
               "Segment %d Template %d Time %f SNR %f Chi^2 %f Sigma %f\n",
               source,pkt.sgmt,pkt.tmpl,pkt.time,pkt.snr,pkt.chisq,pkt.sigma);
    }
    return;
}

/* print out data (just a few points of it) */
void PrintData(DataPacket *pkt,INT4 number,mpiid id)
{
    INT4 i;
    for (i=0;i<number;i++)
        printf("Slave %d==> Segment %d rate %f time %f response[100] %f\n",
               id.myid,pkt[i].sgmt,pkt[i].rate,pkt[i].time,pkt[i].resp[100]);
    fflush(stdout);
    return;
}

/* create some (number) fake events to transmit */
void CreateEvents(EventPacket **list,INT4 number,mpiid id) {
    INT4 i;
    
    (*list)=(EventPacket*)LALMalloc(sizeof(EventPacket)*number);
    for (i=0;i<number;i++) {
        (*list)[i].sgmt=13*i;
        (*list)[i].tmpl=i*i;
        (*list)[i].time=9848.23*i;
        (*list)[i].snr=10*i/(i+3);
        (*list)[i].chisq=36*i;
        (*list)[i].sigma=id.myid;
    }
    return;
}

/* create some (number) of fake templates to transmit */
void CreateTemplates(tempstruct **list,INT4 number){
    INT4 i;
    static INT4 whichcall=1;
    
    *list=(tempstruct*)LALMalloc(sizeof(tempstruct)*number);
    for (i=0;i<number;i++) {        
        (*list)[i].m1=2.0*i+(whichcall++);
        (*list)[i].m2=1.0*i*i/(1.0*whichcall);
        (*list)[i].templatenumber=i+1;
    }
    return;
}

/* create some (number) of fake data segments to transmit */
void CreateData(DataPacket **list,INT4 number) { 
    INT4 i;
    static INT4 whichcall=1;
    
    *list=(DataPacket*)LALMalloc(sizeof(DataPacket)*number);
    for (i=0;i<number;i++) {
        INT4 j;
        (*list)[i].sgmt=i;
        (*list)[i].time=100.0*i;
        (*list)[i].rate=1.0/16384.0;
        for (j=0;j<sgmtsz;j++)
            (*list)[i].data[j]=i+j*(whichcall++);
        for (j=0;j<sgmtsz+2;j++)
            (*list)[i].resp[j]=(i+1.0)*j*whichcall;
        for (j=0;j<sgmtsz/2+1;j++)
            (*list)[i].wght[j]=(i+1.0)/(j+1.0)+whichcall;        
    }
    return;
}
