#ifndef _FRAMEDATA_H
#define _FRAMEDATA_H

#ifndef _LALDATATYPES_H
#include "LALDatatypes.h"
#ifndef _LALDATATYPES_H
#define _LALDATATYPES_H
#endif
#endif

#define FRAMEDATA_ENULL 1
#define FRAMEDATA_ENNUL 2
#define FRAMEDATA_ESIZE 4
#define FRAMEDATA_EDATA 8
#define FRAMEDATA_ERATE 16

#define FRAMEDATA_MSGENULL "Null pointer"
#define FRAMEDATA_MSGENNUL "Non-null pointer"
#define FRAMEDATA_MSGESIZE "Invalid input size"
#define FRAMEDATA_MSGEDATA "End of data"
#define FRAMEDATA_MSGERATE "Invalid sampling rate"

static volatile const char *FRAMEDATAH = "$Id: FrameData.h$";

typedef struct
tagFrameDataPar
{
  INT4  first;
  INT4  timeLastCalibrated;
  void *fgetoutput;
  void *fgetinput;
}
FrameDataPar;

typedef struct
tagFrameDataInp
{
  INT4 seek;
  INT4 seekPoints;
}
FrameDataInp;

typedef struct
tagFrameDataOut
{
  INT4            newLock;
  INT4            newCal;
  INT2TimeSeries *framedata;
}
FrameDataOut;

void
InitializeFrameData (Status *status, FrameDataPar **params);

void
FinalizeFrameData (Status *status, FrameDataPar **params);

void
GetFrameData (
    Status       *status,
    FrameDataOut *output,
    FrameDataInp *input,
    FrameDataPar *params
    );

void
CalibrateFrameData (
    Status                  *status,
    COMPLEX8FrequencySeries *response,
    FrameDataPar            *params
    );

#endif
